//---------------------------------------------------------------------------

#include <vcl.h>
#include "MainAbecedaForm.h"
#pragma hdrstop

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;


//////////////////////////copu from examples - recordtodisk ////////////////////////////
void ERRCHECK(FMOD_RESULT result)
{
    if (result != FMOD_OK)
    {
        printf("FMOD error! (%d) %s\n", result, FMOD_ErrorString(result));
        exit(-1);
    }
}

#if defined(WIN32) || defined(__WATCOMC__) || defined(_WIN32) || defined(__WIN32__)
    #define __PACKED                         /* dummy */
#else
    #define __PACKED __attribute__((packed)) /* gcc packed */
#endif


void WriteWavHeader(FILE *fp, FMOD_SOUND *sound, int length)
{
    int             channels, bits;
    float           rate;

    if (!sound)
    {
        return;
    }

    fseek(fp, 0, SEEK_SET);

    FMOD_Sound_GetFormat  (sound, 0, 0, &channels, &bits);
    FMOD_Sound_GetDefaults(sound, &rate, 0, 0, 0);

    {
        #if defined(WIN32) || defined(_WIN64) || defined(__WATCOMC__) || defined(_WIN32) || defined(__WIN32__)
        #pragma pack(1)
        #endif
        
        /*
            WAV Structures
        */
        typedef struct
        {
	        signed char id[4];
	        int 		size;
        } RiffChunk;
    
        struct
        {
            RiffChunk       chunk           __PACKED;
            unsigned short	wFormatTag      __PACKED;    /* format type  */
            unsigned short	nChannels       __PACKED;    /* number of channels (i.e. mono, stereo...)  */
            unsigned int	nSamplesPerSec  __PACKED;    /* sample rate  */
            unsigned int	nAvgBytesPerSec __PACKED;    /* for buffer estimation  */
            unsigned short	nBlockAlign     __PACKED;    /* block size of data  */
            unsigned short	wBitsPerSample  __PACKED;    /* number of bits per sample of mono data */
        } FmtChunk  = { {{'f','m','t',' '}, sizeof(FmtChunk) - sizeof(RiffChunk) }, 1, channels, (int)rate, (int)rate * channels * bits / 8, 1 * channels * bits / 8, bits } __PACKED;

        struct
        {
            RiffChunk   chunk;
        } DataChunk = { {{'d','a','t','a'}, length } };

        struct
        {
            RiffChunk   chunk;
	        signed char rifftype[4];
        } WavHeader = { {{'R','I','F','F'}, sizeof(FmtChunk) + sizeof(RiffChunk) + length }, {'W','A','V','E'} };

        #if defined(WIN32) || defined(_WIN64) || defined(__WATCOMC__) || defined(_WIN32) || defined(__WIN32__)
        #pragma pack()
        #endif
      
        /*
            Write out the WAV header.
        */
        fwrite(&WavHeader, sizeof(WavHeader), 1, fp);
        fwrite(&FmtChunk, sizeof(FmtChunk), 1, fp);
        fwrite(&DataChunk, sizeof(DataChunk), 1, fp);
    }
}






void TForm1::SaveToWav(FMOD_SOUND *sound,const char *filename)
{

FILE  *fp;
unsigned int datalength = 0, soundlength;
unsigned int recordpos = 0;
void *ptr1, *ptr2;
unsigned int len1, len2;


fp = fopen(filename, "wb");
WriteWavHeader(fp, sound, datalength);

result = FMOD_Sound_GetLength(sound, &soundlength, FMOD_TIMEUNIT_PCM);
ERRCHECK(result);

FMOD_System_GetRecordPosition(system, &recordpos);
ERRCHECK(result);

int blocklength = (int)recordpos;
/*
    Lock the sound to get access to the raw data.
*/
FMOD_Sound_Lock(sound, 0, blocklength * exinfo.numchannels * 2, &ptr1, &ptr2, &len1, &len2);

/*
    Write it to disk.
*/
if (ptr1 && len1)
{
    datalength += fwrite(ptr1, 1, len1, fp);
}
/*
    Unlock the sound to allow FMOD to use it again.
*/
FMOD_Sound_Unlock(sound, ptr1, ptr2, len1, len2);

WriteWavHeader(fp, sound, datalength);

fclose(fp);

}


////////////////////////////////end ///////////////////////////////////////////////////

__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//***********************************************************************

void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
        TShiftState Shift)
{
if (!nahravam && (Key == VK_SPACE))
  {
  result = FMOD_System_RecordStart(system, sound, FALSE);
  ERRCHECK(result);
  nahravam=true;
  } // if
} // procedure

//---------------------------------------------------------------------------

void __fastcall TForm1::FormKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
if (Key == VK_SPACE)
  {
 result = FMOD_System_RecordStop(system);
 ERRCHECK(result);
 AnsiString s;
 s = pismeno[vybrate_pismeno]->get_path() +"\\"+IntToStr(pismeno[vybrate_pismeno]->get_counter()) + ".wav";
 SaveToWav(sound,s.c_str());
 if (pokus != 46)
    {
    int i=random(POCET_PISMEN - pokus)+1;
    int j=0;
    while (i!=0)
      {
      if (pismeno[j]->picked) j++;
      else
        {
        i--;
        j++;
        }
      }
    vybrate_pismeno = j - 1;
    pismeno[vybrate_pismeno]->picked=true;
    pokus++;
    pismeno[vybrate_pismeno]->nakresli(400,200,Image1);
    }
 else
   {
   Image1->Picture->LoadFromFile("ticho1.bmp");
   Application->ProcessMessages();
   Sleep(500);
   Image1->Picture->LoadFromFile("ticho2.bmp");
   Application->ProcessMessages();
   Sleep(500);
   Image1->Picture->LoadFromFile("ticho3.bmp");
   Application->ProcessMessages();
   Sleep(500);
   Application->Terminate();
   }
  nahravam = false;
  }
}

//******************************************************************************

void __fastcall TForm1::FormShow(TObject *Sender)
{
Top = 0;
Left = 0;
Height = 760;
Width = 1000;
Image1->Canvas->Brush->Color = clBlack;
Image1->Canvas->Font->Size=60;
Image1->Picture->LoadFromFile("blackboard.bmp");
pokus = 0;
nahravam=false;
DoubleBuffered=true;


int i=random(POCET_PISMEN - pokus)+1;
int j=0;
while (i!=0)
  {
  if (pismeno[j]->picked) j++;
  else
    {
    i--;
    j++;
    }
  }
vybrate_pismeno = j - 1;
pismeno[vybrate_pismeno]->picked=true;
pokus++;
pismeno[vybrate_pismeno]->nakresli(400,200,Image1);
} // FormShow

//******************************************************************************

void __fastcall TForm1::FormCreate(TObject *Sender)
{
//initialization
system  = 0;
TimeSeparator = '.';
FTime = TDateTime::CurrentTime();
//ForceDirectories(".\\" + FTime);
datalength = 0;
result = FMOD_System_Create(&system);
ERRCHECK(result);

result = FMOD_System_GetVersion(system, &version);
ERRCHECK(result);

if (version < FMOD_VERSION)
{
    printf("Error!  You are using an old version of FMOD %08x.  This program requires %08x\n", version, FMOD_VERSION);
}
result = FMOD_System_Init(system, 32, FMOD_INIT_NORMAL, 0);
    ERRCHECK(result);

memset(&exinfo, 0, sizeof(FMOD_CREATESOUNDEXINFO));

exinfo.cbsize           = sizeof(FMOD_CREATESOUNDEXINFO);
exinfo.numchannels      = 1;
exinfo.format           = FMOD_SOUND_FORMAT_PCM16;
exinfo.defaultfrequency = 16000;
exinfo.length           = exinfo.defaultfrequency * sizeof(short) * exinfo.numchannels * 10;

result = FMOD_System_CreateSound(system, 0, FMOD_2D | FMOD_SOFTWARE | FMOD_OPENUSER, &exinfo, &sound);
ERRCHECK(result);

// end of initialization

randomize();
AnsiString alphabet[POCET_PISMEN]={'A','','','B','C','','D','',"Dz","D",'E','','F','G','H',"Ch",'I','','J','K','L','','','M','N','','O','','','P','Q','R','','S','','T','','U','','V','W','X','Y','','Z',''};
AnsiString s;
for (int i=0;i<POCET_PISMEN;i++)
  {
  AnsiString s;
  s = ".\\vzorky\\" + alphabet[i];
  ForceDirectories(s);
  pismeno[i]=new TPismeno(alphabet[i],s);
  } // for
pismeno[2]->set_popis("< irok e >");
pismeno[42]->set_popis("< ypsilon >");
pismeno[43]->set_popis("< dlh ypsilon >");
pismeno[40]->set_popis("< dvojit v >");
pismeno[41]->set_popis("< iks >");
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormDestroy(TObject *Sender)
{
result = FMOD_Sound_Release(sound);
ERRCHECK(result);

result = FMOD_System_Release(system);
ERRCHECK(result);
}
//---------------------------------------------------------------------------

