//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainDeciderUnit.h"
# include <algorithm>
# include <numeric>
#include <dir.h>
using namespace std;


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainDeciderForm *MainDeciderForm;
//---------------------------------------------------------------------------
__fastcall TMainDeciderForm::TMainDeciderForm(TComponent* Owner)
        : TForm(Owner)
{
DecimalSeparator = '.';
testDataPath = "TestData1\\";
separator = "--------------------------------------------------------------------------------------";
}
//---------------------------------------------------------------------------
void __fastcall TMainDeciderForm::Button1Click(TObject *Sender)
{

Word msec;
Word a;
Word b;
Word c;
Memo->Lines->Add("Evaluating " + InputEdit->Text);
TDateTime DateTime = TDateTime::CurrentTime();
AnsiString s;
if (AlgorithmRadioGroup->ItemIndex == 1)  s = Evaluate1(CDecisionVertex::LoadMFCCFromFile(testDataPath + InputEdit->Text), true);
else  s = Evaluate2(CDecisionVertex::LoadMFCCFromFile(testDataPath + InputEdit->Text), true);

if (s == "NO_INPUT") return;
Memo->Lines->Add("Winning class is " + s);
DateTime =  TDateTime::CurrentTime() - DateTime;
DecodeTime(DateTime, a, b, c, msec);
Memo->Lines->Add(IntToStr(msec) + "  ms");
}

//---------------------------------------------------------------------------

void TMainDeciderForm::GetDecisionClasses (AnsiString s1, AnsiString s2, DecisionClass &d1, DecisionClass &d2)
{
TStringList* temp = new TStringList();
try
  {
  d1.clear();
  temp->DelimitedText = s1;
  for (int i=0; i< temp->Count ;i++)
    {
    d1.push_back(UpperCase(temp->Strings[i]));
    }

  d2.clear();
  temp->DelimitedText = s2;
  for (int i=0; i< temp->Count ;i++)
    {
    d2.push_back(UpperCase(temp->Strings[i]));
    }
  }
catch (...)
 {
 temp->Free();
 }
}

//---------------------------------------------------------------------------

void __fastcall TMainDeciderForm::FormShow(TObject *Sender)
{
Memo->Lines->Add("Loading DecisionLayer1");
Application->ProcessMessages();
layer1 = new CDecisionLayer ("PBVTD MN F KGCH ҼJ L R H SZCDZ D A O U E I", ".\\ExportedNN\\Layer1");
Memo->Lines->Add("Loaded decision vertexes: " + IntToStr(layer1->m_DecisionVertexField.size()));
Memo->Lines->Add("Loading DecisionLayer2");
Application->ProcessMessages();
DecisionClass d1;
DecisionClass d2;

layer2[0] = new CDecisionLayer ("P B V T D", ".\\ExportedNN\\Layer2");
layer2[1] = new CDecisionLayer ("M N", ".\\ExportedNN\\Layer2");
layer2[3] = new CDecisionLayer ("K G CH", ".\\ExportedNN\\Layer2");
layer2[4] = new CDecisionLayer ("    J", ".\\ExportedNN\\Layer2");
layer2[8] = new CDecisionLayer ("S Z C DZ", ".\\ExportedNN\\Layer2");
layer2[9] = new CDecisionLayer ("   D", ".\\ExportedNN\\Layer2");
layer2[12] = new CDecisionLayer (" U", ".\\ExportedNN\\Layer2");
Memo->Lines->Add("Loading successful");
Memo->Lines->Add(separator);
}

//---------------------------------------------------------------------------

void __fastcall TMainDeciderForm::SuccessfulnessClick(TObject *Sender)
{
  if (AlgorithmRadioGroup->ItemIndex == 0) Memo->Lines->Add("Computing succesfulness for winner-only algorithm");
  else Memo->Lines->Add("Computing succesfulness for threshold algorithm - T1=" + FirstThreshold->Text +
     ", T2=" + SecondThreshold->Text);


  struct ffblk ffblk;
  struct result
    {
    AnsiString className;
    vector<AnsiString> mistake;
    int ok;
    } resultField[33];

  TStringList *temp = new TStringList();
  temp->DelimitedText = "P B V T D M N F K G CH     J L R H S Z C Dz    D A O  U E I";
  for (int i = 0; i < 33; i++)
    {
    resultField[i].className = UpperCase(temp->Strings[i]);
    resultField[i].ok = 0;
    }

  Word msec;
  Word a;
  Word b;
  Word c;
  int count = 0;
  TDateTime DateTime = TDateTime::CurrentTime();
  AnsiString s = testDataPath + "*.mfcc";
  int done = findfirst(s.c_str(), &ffblk, 0);
  while (!done)
    {
    AnsiString s1(ffblk.ff_name);
    AnsiString winClass;

    if (AlgorithmRadioGroup->ItemIndex == 1) winClass = UpperCase(Evaluate1(CDecisionVertex::LoadMFCCFromFile(testDataPath + s1)));
    else winClass = UpperCase(Evaluate2(CDecisionVertex::LoadMFCCFromFile(testDataPath + s1)));
    AnsiString temp = s1;
    if ((s1[2] >= '0')  && (s1[2] <= '9')) s1.SetLength(1);
    else s1.SetLength(2);

    if ((s1 == "A") ||  (s1 == "")) s1 = "A";
    if ((s1 == "O") ||  (s1 == "")) s1 = "O";
    if ((s1 == "U") ||  (s1 == "")) s1 = "U";
    if ((s1 == "E") ||  (s1 == "")) s1 = "E";
    if ((s1 == "I") ||  (s1 == ""))s1 = "I";
    if ((s1 == "L") ||  (s1 == "")) s1 = "L";
    if ((s1 == "R") ||  (s1 == "")) s1 = "R";
    if (s1 == "D") s1 = "D";
    int pos = 0;

    while (resultField[pos].className != UpperCase(s1))
      pos++;

    if (winClass == resultField[pos].className) resultField[pos].ok++;
    else resultField[pos].mistake.push_back(winClass);

    done = findnext(&ffblk);
    count++;
    }
  DateTime =  TDateTime::CurrentTime() - DateTime;
  DecodeTime(DateTime, a, b, c, msec);
  msec = msec + 1000*c + 60*1000*b + 60*60*1000*a;
  if (count != 0) msec /= double(count);
  Memo->Lines->Add("Average time: " + FloatToStr(msec) + "ms");

  FILE *all;
  all = fopen(".\\Results\\results.txt", "w");
  int global = 0;
  for (int i = 0; i < 33; i++)
    {
    fprintf(all, "\n");
    fprintf(all, resultField[i].className.c_str());
    fprintf(all, "\n");
    float f = (resultField[i].ok);
    fprintf(all, FloatToStr(f).c_str());
    fprintf(all, "\n");
    global += resultField[i].ok;
    for (size_t j = 0; j < resultField[i].mistake.size(); j++)
      {
      fprintf(all, resultField[i].mistake[j].c_str());
      fprintf(all, " ");
      }
    fprintf(all, "\n");
    }


 fprintf(all, ("Succussfulness is " + FloatToStr(100*RoundTo(double(global)/ (double)count, -4)) + "%").c_str());
 fclose(all);

Memo->Lines->Add("Results written in Results\\results.txt");
Memo->Lines->Add(separator);

}
//---------------------------------------------------------------------------
AnsiString TMainDeciderForm::Evaluate1 (MFCCVectors input, bool showResult)
{
if (input.empty()) return "NO_INPUT";
vector <int> temp;
vector<Likelihood> result;
int maxIndex = 0;
double maxValue = 0;
float T1 = StrToFloatDef(FirstThreshold->Text, 1.5);
float T2 = StrToFloatDef(SecondThreshold->Text, 2.5);
//if (showResult) Memo->Lines->Clear();
TStringList *strList = new TStringList();


layer1->EvaluateLayer(input);     // vyhodnot prvu vrstvu

for (int j = 0; j < 15; j++)       // spracuj prvu vrstvu => zapamataj si tie casti co maju dost dobru pravedpodobnost
  if (layer1->m_LikelihoodDisField[j] > T1)
    if (layer2[j] != NULL) temp.push_back(j);
    else
      if (layer1->m_LikelihoodDisField[j] * layer1->m_LikelihoodDisField[j] > T2)
        {
        Likelihood tempL;
        tempL.value = layer1->m_LikelihoodDisField[j] * layer1->m_LikelihoodDisField[j];
        strList->DelimitedText = layer1->GetClassString();
        tempL.letter = strList->Strings[j];
        result.push_back(tempL);
        }

/*for (size_t i = 0; i < result.size(); i++)
  result[i].value *= result[i].value;*/ 


if (showResult) Memo->Lines->Add("Evaluation finished");

for (size_t i = 0; i < temp.size(); i++)
  {
  layer2[temp[i]]->EvaluateLayer(input);  // vypocitaj prislusne druhe vrstvy
  layer2[temp[i]]->MultiplyLikelihoodDisField(layer1->m_LikelihoodDisField[temp[i]]);  // posun medzi intervalmi<-2,2> -> <-1,1>

  for (size_t j = 0; j < layer2[temp[i]]->m_LikelihoodDisField.size(); j++)
    if (layer2[temp[i]]->m_LikelihoodDisField[j] > T2)
        {
        Likelihood tempL;
        tempL.value = layer2[temp[i]]->m_LikelihoodDisField[j];
        strList->DelimitedText = layer2[temp[i]]->GetClassString();
        tempL.letter = strList->Strings[j];
        result.push_back(tempL);
        }
  }
maxIndex = -1;
maxValue = 0;

for (size_t i = 0; i < result.size(); i++)
  {
  if (showResult)Memo->Lines->Add(result[i].letter);
  if (showResult)Memo->Lines->Add(FloatToStr(result[i].value));
  if (maxValue < result[i].value)
    {
    maxIndex = i;
    maxValue = result[i].value;
    }
  }
strList->~TStringList();
if (maxIndex == -1) return "unrecognized";
else return result[maxIndex].letter;
}

//---------------------------------------------------------------------------

AnsiString TMainDeciderForm::Evaluate2 (MFCCVectors input, bool showResult)
{
if (input.empty()) return "NO_INPUT";
if (showResult) Memo->Lines->Clear();
TStringList *strList = new TStringList();

layer1->EvaluateLayer(input);     // vyhodnot prvu vrstvu
vector <int> temp;
vector<Likelihood> result;
int maxIndex = 0;
double maxValue = 0;

for (int j = 0; j < 15; j++)
  if (maxValue < layer1->m_LikelihoodDisField[j])
    {
    maxIndex = j;
    maxValue = layer1->m_LikelihoodDisField[j];
    }

if (layer2[maxIndex] != NULL) temp.push_back(maxIndex);
    else
      {
      Likelihood tempL;
      tempL.value = layer1->m_LikelihoodDisField[maxIndex];
      strList->DelimitedText = layer1->GetClassString();
      tempL.letter = strList->Strings[maxIndex];
      result.push_back(tempL);
      }

if (showResult) Memo->Lines->Add("Evaluation finished");

for (size_t i = 0; i < temp.size(); i++)
  {
  layer2[temp[i]]->EvaluateLayer(input);  // vypocitaj prislusne druhe vrstvy
  layer2[temp[i]]->MultiplyLikelihoodDisField(layer1->m_LikelihoodDisField[temp[i]]);

  for (size_t j = 0; j < layer2[temp[i]]->m_LikelihoodDisField.size(); j++)
   //if (layer2[temp[i]]->m_LikelihoodDisField[j] > 0. )
        {
        Likelihood tempL;
        tempL.value = layer2[temp[i]]->m_LikelihoodDisField[j];
        strList->DelimitedText = layer2[temp[i]]->GetClassString();
        tempL.letter = strList->Strings[j];
        result.push_back(tempL);
        }
  }
maxIndex = 0;
maxValue = 0;

for (size_t i = 0; i < result.size(); i++)
  {
  if (showResult)Memo->Lines->Add(result[i].letter);
  if (showResult)Memo->Lines->Add(FloatToStr(result[i].value));
  if (maxValue < result[i].value)
    {
    maxIndex = i;
    maxValue = result[i].value;
    }
  }
strList->~TStringList();
return result[maxIndex].letter;
}

//---------------------------------------------------------------------------

void __fastcall TMainDeciderForm::testingSetRadioGroupClick(TObject *Sender)
{
if (testingSetRadioGroup->ItemIndex == 0)  testDataPath = "TestData1\\";
else testDataPath = "TestData2\\";

}
//---------------------------------------------------------------------------

