//---------------------------------------------------------------------------
#include <vector>
#include "CNeuralNetwork.h"
#include "CLengthDecision.h"

#ifndef CDecisionLayerH
#define CDecisionLayerH

class CDecisionLayer
  {
  private:
    AnsiString m_ClassString;
  private:
    double Mult (vector<double> src, int omit1 = -1, int omit2 = -1);
  public:
    int m_MaxProbIndex;
  public:
    vector<CDecisionVertex*> m_DecisionVertexField;
  public:
    vector<double> m_LikelihoodDisField;
  public:
    CDecisionLayer ();
  public:
    CDecisionLayer (const AnsiString classString, const AnsiString searchPath); //Nacitanie neuronovych sieti
  public:
    CDecisionLayer (const DecisionClass decisionClass1, const DecisionClass decisionClass2, const int border); // naciatanie rozhodovania podla dlzky
  public:
    void EvaluateLayer (const MFCCVectors input, BOOL useAprox = true);
  public:
    void MultiplyLikelihoodDisField (double value);
  public:
    AnsiString GetClassString  ()
      {
      return m_ClassString;
      }
  public:
    void AddToLines(TStrings *lines, int classIndex = -1);

  };
//---------------------------------------------------------------------------
#endif
