//---------------------------------------------------------------------------
//#define CLASSCOUNT 16
#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "TestingAppForm.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TTestingForm *TestingForm;
//---------------------------------------------------------------------------
__fastcall TTestingForm::TTestingForm(TComponent* Owner)
        : TForm(Owner)
{
DecimalSeparator = '.';

}
//---------------------------------------------------------------------------
void __fastcall TTestingForm::trainButtonClick(TObject *Sender)
{
double normalization[12][3] = {{20, 20, 20},{20, 20, 5},{20, 10, 10}, {10, 10, 0}, {20, 5, 0.5},
                      {20, 1, 1}, {10, 2, 0.5}, {20, 10, 1}, {20, 2, 0.1}, {20, 0.5, 0.1},
                      {20, 5, 0}, {20, 1, 0}};
//int n_Hidden[4] = {50};
/*AnsiString dClasses[CLASSCOUNT] = {"P B M",  "T D N", "V" , "F" ,"K G CH", "    J", "L ", "R ", "H", "S Z C DZ", "   D",
           "A ", "O ", " U ", "E ", "I "};
                                                  // {"L ", "S Z C DZ"};//
AnsiString bestResults[CLASSCOUNT][CLASSCOUNT];   */
vector <AnsiString> dClasses;
vector < vector<AnsiString> > bestResults;

Memo->Lines->Add("Neural Networks Training");
TStringList* tempStringList = new TStringList();
try
  {
  AnsiString classes = "Classes:";
  tempStringList->CommaText = (ClassInputEdit->Text);
  dClasses.resize(tempStringList->Count);
  bestResults.resize(tempStringList->Count);
  for (size_t i = 0; i < dClasses.size(); i++)
    {
    dClasses[i] = tempStringList->Strings[i];
    bestResults[i].resize(tempStringList->Count);
    classes +=  (tempStringList->Strings[i] + " ");
    }
  Memo->Lines->Add(classes);
  }
__finally
 {
 tempStringList->Free();
 }
Application->ProcessMessages();
AnsiString s = "";
int counter;
int errorCounter;
double prevError;
double minError;
double currError;
double globeMinError;
FILE *all;
FILE *best;
DecisionClass d1;
DecisionClass d2;
Boolean stop;

all = fopen(".\\Results\\all.txt", "w");
for (size_t i = 0; i < dClasses.size(); i++)
  for (size_t j = i+1; j < dClasses.size(); j++)
  {
  GetDecisionClasses(dClasses[i], dClasses[j], d1, d2);
  globeMinError = MaxDouble;
  int a=0;
  stop = false;
  Memo->Lines->Add("Training Neural Netwrok for decision classes " +
    DecisionClassToString(d1) + " " +  DecisionClassToString(d2));
  Application->ProcessMessages();
  while (a < 1 && !stop)
    {
    int b=0;
    while (b < 12 && !stop)
          {
          if (n != NULL) n->~CTrainableNeuralNetwork();

          n = new CTrainableNeuralNetwork(d1, d2,
            260, 50, 10, normalization[b][0], normalization[b][1], normalization[b][2]);

          n->MakeTrainigAndTestingSet(70);
          minError = MaxDouble;
          for (int k = 0; k < 2; k++)
            {
            n->ResetWeights();
            n->Train(10, 0.1); // najskor 10
            counter = 10;
            errorCounter = 0;
            prevError = n->ErrorOnTestingSet();
            while ((prevError > 0.5) && (errorCounter < 3) && counter < 100)
              {
              n->Train(1, 0.1);  // a potom po jednej
              counter++;
              currError = n->ErrorOnTestingSet();
              if ((currError + 0.002) >= prevError) errorCounter++;
              else errorCounter = 0;
              prevError = currError;
              }

            if (minError > prevError)
              {
              minError = prevError;
              s = IntToStr(counter) + " " + n->GetNNParameters() + " " +
                FloatToStr(RoundTo(n->ErrorOnTrainingSet(), -3)) + " " +
                FloatToStr(RoundTo( n->ErrorOnTestingSet(), -3)) + " " +
                FloatToStr(RoundTo( n->ErrorInPercentOnTrainingSet(0.5), -2)) + "% " +
                FloatToStr(RoundTo( n->ErrorInPercentOnTestingSet(0.5), -2)) + "%";
                
              if (globeMinError > minError)
                {
                globeMinError = minError;
                bestResults [i][j] = s;
                n->ExportToFile(".\\ExportedNN\\" + n->GetDecisionClass1()+"-"+n->GetDecisionClass2()+".nne");
                }
              if (globeMinError < 0.3) stop = true;
              }
            }
          fprintf(all, s.c_str());
          fprintf(all, "\n");
          b++;
          }
    a++;
    }
  Memo->Lines->Add("done");
  Application->ProcessMessages();
  }

fclose(all);
best = fopen(".\\Results\\best.txt", "w");
for (size_t i = 0; i < dClasses.size(); i++)
  for (size_t j = i+1; j < dClasses.size(); j++)
    {
    fprintf(best, bestResults[i][j].c_str());
    fprintf(best, "\n");
    }

fclose(best);

Memo->Lines->Add("Training completed. Results written in \"Results\\all.txt\" and \"Results\\best.txt\"");
}

//---------------------------------------------------------------------------

void __fastcall TTestingForm::Button1Click(TObject *Sender)
{
double temp[12][3] = {{20, 20, 20},{20, 20, 5},{20, 10, 10}, {10, 10, 0}, {20, 5, 0.5},
                      {20, 1, 1}, {10, 2, 0.5}, {20, 10, 1}, {20, 2, 0.1}, {20, 0.5, 0.1},
                      {20, 5, 0}, {20, 1, 0}};

double temp2[12] = {0,0,0,0,0,0,0,0,0,0,0,0,};
DecisionClass d1;
DecisionClass d2;
vector <AnsiString> dClasses;
vector < vector<AnsiString> > bestResults;

Memo->Lines->Add("Testing DTW algorithm");
TStringList* tempStringList = new TStringList();
try
  {
  tempStringList->CommaText = (ClassInputEdit->Text);

  if (tempStringList->Count != 2)
    {
    Memo->Lines->Add("Error! DTW algorithm requires two decision classes.");
    exit;
    }
  GetDecisionClasses(tempStringList->Strings[0], tempStringList->Strings[1], d1, d2);
  Memo->Lines->Add("Classes: " + DecisionClassToString(d1) + " " + DecisionClassToString(d2));
  }
__finally
  {
  tempStringList->Free();
  }
Application->ProcessMessages();


for (int j = 0 ; j < 12; j++)
  {
  for (int i = 0; i < 10; i++)
    {
    CTestDTWDecisionVertex *dtw = new CTestDTWDecisionVertex(d1, d2, 10, temp[j][0], temp[j][1], temp[j][2], 0.7);
    temp2[j] += dtw->Test();
    dtw->~CTestDTWDecisionVertex();
    }
  Memo->Lines->Add("Normalization: " + FloatToStr(temp[j][0]) + " " + FloatToStr(temp[j][1])+ " " + FloatToStr(temp[j][2]) + " " +
    "     Successfulness: " + FloatToStr(RoundTo(temp2[j] * 10., -2)) + "%");
  Application->ProcessMessages();
  }
Memo->Lines->Add("Testing completed.");
}
//---------------------------------------------------------------------------

void TTestingForm::GetDecisionClasses (AnsiString s1, AnsiString s2, DecisionClass &d1, DecisionClass &d2)
{
TStringList* temp = new TStringList();
try
  {
  temp->Delimiter = ' ';
  d1.clear();
  temp->DelimitedText = s1;
  for (int i=0; i< temp->Count ;i++)
    {
    d1.push_back(UpperCase(temp->Strings[i]));
    }

  d2.clear();
  temp->DelimitedText = s2;
  for (int i=0; i< temp->Count ;i++)
    {
    d2.push_back(UpperCase(temp->Strings[i]));
    }
  }
__finally

 {
 temp->Free();
 }

}

//---------------------------------------------------------------------------

AnsiString TTestingForm::DecisionClassToString(DecisionClass d)
{
AnsiString result = "";

for (size_t i = 0; i < d.size(); i++)
  result += (d[i]);

return result;
}

void __fastcall TTestingForm::ClassInputEditClick(TObject *Sender)
{
if (ClassInputEdit->Tag == 0)
  {
  ClassInputEdit->Text = "";
  ClassInputEdit->Tag = 1;
  }        
}
//---------------------------------------------------------------------------

