//---------------------------------------------------------------------------
#include "CDecisionVertex.h"
#ifndef CDTWDecisionVertexH
#define CDTWDecisionVertexH
class CDTWDecisionVertex: public CDecisionVertex
  {
  protected:
    vector<MFCCVectors> m_SampleSet1;
  protected:
    vector<MFCCVectors> m_SampleSet2;
  protected:
    double m_MaxMFCC;
  protected:
    double m_MaxDelta;
  protected:
    double m_MaxEnergy;
  protected:
    inline double Normalize(double value, double maxValue)
      {
      if (maxValue == 0)  return 0;
      double result = value  /  maxValue;
      if (result > 1) return 1;
      if (result < -1) return -1;
      return result;
      }// vrati normalizovanu hodnotu tj. z intervalu <-1,1>
  protected:
    inline double Min(const double a, const double b, const double c)
      {
      if (a<b)
        {
        if (a<c) return a;
        else return c;
        }
      else
        {
        if (b<c) return b;
        else return c;
        }
      }
  protected:
    double Distance (const MFCCVector a, const MFCCVector b);
  protected:
    double DTWDistance(const MFCCVectors a, const MFCCVectors b); // vypocita vzdialenost medzi dvomi MFCCVectors
  public:
    CDTWDecisionVertex(DecisionClass decisionClass1, DecisionClass decisionClass2,
      int mfccCount, double maxMFCC, double maxDelta, double maxEnergy);
  public:
    ~CDTWDecisionVertex();
  public:
    LikelihoodDistribution ComputeLikelihood(MFCCVectors mFCCInput);
  public:
    void LoadSampleSet(const AnsiString directory,int classIndex, bool delta = true, bool energy = true);
  public:
    void NormalizedMFCCVectors(MFCCVectors& mFCCInput); // znormalizuje vectory do <-1,1> a upravy na velkost pomocou spektralnej cesty
  };
//---------------------------------------------------------------------------
#endif
