//---------------------------------------------------------------------------


#pragma hdrstop

#include "CTestDTWDecisionVertex.h"
#include <algorithms.h>
#include <math.h>
//---------------------------------------------------------------------------

#pragma package(smart_init)



CTestDTWDecisionVertex::CTestDTWDecisionVertex(DecisionClass decisionClass1, DecisionClass decisionClass2,
  int mfccCount, double maxMFCC, double maxDelta, double maxEnergy, double Testing_SampleRatio)
  :CDTWDecisionVertex(decisionClass1, decisionClass2, mfccCount, maxMFCC, maxDelta, maxEnergy)
  {
  random_shuffle(m_SampleSet1.begin(), m_SampleSet1.end());
  random_shuffle(m_SampleSet2.begin(), m_SampleSet2.end());
  m_TestSet1.resize(0);
  m_TestSet2.resize(0);


  int temp = ceil(Testing_SampleRatio * m_SampleSet1.size());

  for (size_t i = temp; i < m_SampleSet1.size() ;i++)
    m_TestSet1.push_back(m_SampleSet1[i]);

  m_SampleSet1.resize(temp);

  temp = ceil(Testing_SampleRatio * m_SampleSet2.size());

  for (size_t i = temp; i < m_SampleSet2.size() ;i++)
    m_TestSet2.push_back(m_SampleSet2[i]);

  m_SampleSet2.resize(temp);
}
//---------------------------------------------------------------------------

double CTestDTWDecisionVertex::Test()
{
int count = 0;
for (size_t i = 0; i < m_TestSet1.size() ;i++)
  {
  LikelihoodDistribution temp  = ComputeLikelihood(m_TestSet1[i]);
  if (temp.likelihood1 == 2) count++;
  }

for (size_t i = 0; i < m_TestSet2.size() ;i++)
  {
  LikelihoodDistribution temp  = ComputeLikelihood(m_TestSet2[i]);
  if (temp.likelihood2 == 2) count++;
  }

return double(count)/ double(m_TestSet1.size() + m_TestSet2.size());
}

//---------------------------------------------------------------------------
